## binutils-arm64-cross 0.5

=== debian/changelog ===
binutils-arm64-cross (0.5) raring; urgency=low

  * Build-depend on binutils-source (>= 2.23.2-1ubuntu2).

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Mar 2013 10:19:37 +0100

binutils-arm64-cross (0.4) raring; urgency=low

  * Build-depend on binutils-source (>= 2.23.1-0ubuntu10).
  * For cross builds, add the tool libdir to the library search path.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Feb 2013 16:15:37 +0100
