## binutils-arm64-cross 0.9

=== debian/changelog ===
binutils-arm64-cross (0.9) saucy; urgency=low

  * Build-depend on binutils-source (>= 2.23.52.20130913-0~).

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Oct 2013 17:00:30 +0200

binutils-arm64-cross (0.8) saucy; urgency=low

  * Build-depend on binutils-source (>= 2.23.52.20130722-1~).

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Jul 2013 23:18:16 +0200

binutils-arm64-cross (0.7) saucy; urgency=low

  * Build-depend on binutils-source (>= 2.23.52.20130620-1~).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Jun 2013 17:38:09 +0200

binutils-arm64-cross (0.6) saucy; urgency=low

  * Build-depend on binutils-source (>= 2.23.52.20130611-1~).

 -- Matthias Klose <doko@ubuntu.com>  Tue, 11 Jun 2013 15:12:26 +0200
