=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: binutils-arm64-cross
 Section: devel
 Priority: extra
-#Maintainer: Ubuntu Core developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Maintainer: Marcin Juszkiewicz <marcin.juszkiewicz@linaro.org>
+Maintainer: Ubuntu Core developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Standards-Version: 3.9.3
 Build-Depends: dpkg-dev (>= 1.13.9), autoconf (>= 2.64), bison, flex, gettext,
   texinfo, dejagnu (>= 1.4.2-1.1), quilt, file, xz-utils, lsb-release,
   zlib1g-dev,
-  binutils-source (>= 2.23.2-1ubuntu2)
+  binutils-source (>= 2.23.52.20130913-0~)
 Vcs-Browser: http://git.linaro.org/gitweb?p=people/hrw/cross-toolchain-packaging.git;a=shortlog;h=refs/heads/debian/experimental/arm64-cross-toolchain-base
 Vcs-git: git://git.linaro.org/people/hrw/cross-toolchain-packaging.git
