=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 EXTRA_DEPS :=
 
-MIN_VER_BINUTILS     = 2.23.2-1ubuntu2
+MIN_VER_BINUTILS     = 2.23.52.20130913-0~
 
 ifeq ($(PPA),false)
